/*
 * File: Screen_Select_Value.c
 *
 * Created: Created: Friday August 2025 13:35:25
 *   Author: Chris
 */

// ============================================================================================
// Includes
#include "../Screens.h"
#include "../UI_Control.h"
#include "../Command_Definition.h"

#include "../Display.h"
#include "../Display_Objects.h"
#include "../Display_Default_Configurations.h"


// ============================================================================================
// Variables
static Object_ID _Object_Message_Box;

static const Hierarchical_Menu* _Return_Menu = NULL;
static const Menu_List*         _Return_List = NULL;
static int32_t                  _Return_Selected_Item;

static char*        _Title;
static uint32_t     _Title_Length;
static int32_t*  	_Value;
static int32_t  	_Display_Value;
static const Menu_Configuration_Select_Value* _Config;

static bool	        _Decision_Made;
static uint32_t	    _Counter;


// ============================================================================================
// Function Declarations
void Screen_Setup_Select_Value(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration, char* title, uint32_t title_length, int32_t* value, const Menu_Configuration_Select_Value* config, const Hierarchical_Menu* return_menu, const Menu_List* return_list, int32_t return_selected_item);

static void Screen_Init                 (Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration);
static void Screen_Tick					(void);
static void Screen_Click				(uint button_return_value);
static void Screen_Touch_Event			(int16_t x, int16_t y);
static void Screen_Action_CW			(Object_ID object_id);
static void Screen_Action_CCW			(Object_ID object_id);
static void Screen_On_Object_Focused	(Object_ID object_id);
static void Screen_On_Object_Defocused	(Object_ID object_id);
static void Screen_On_Object_Select		(Object_ID object_id);
static void Screen_On_Object_Deselect	(Object_ID object_id);


/*******************************************************************
    Functions
*******************************************************************/
void Screen_Setup_Select_Value(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration, char* title, uint32_t title_length, int32_t* value, const Menu_Configuration_Select_Value* config, const Hierarchical_Menu* return_menu, const Menu_List* return_list, int32_t return_selected_item)
{
    _Title = title;
    _Title_Length = title_length;
    _Value = value;
    _Display_Value = *value * config->Value_Display_Ratio;
	_Config = config;

    Screen_Init(direction_out, direction_in, type, frame_duration);

    _Return_Menu = return_menu;
    _Return_List = return_list;
    _Return_Selected_Item = return_selected_item;

    _Decision_Made = false;
    _Counter = 0;
}

void Screen_Init(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration)
{
    _Screen_Tick                    = Screen_Tick;
    _Screen_Tick					= Screen_Tick;
	_Screen_Click					= Screen_Click;
	_Screen_Touch_Event				= Screen_Touch_Event;
	_Screen_Action_CW				= Screen_Action_CW;
	_Screen_Action_CCW				= Screen_Action_CCW;
	_Screen_On_Objects_Focused 		= Screen_On_Object_Focused;
	_Screen_On_Objects_Defocused 	= Screen_On_Object_Defocused;
	_Screen_On_Object_Select		= Screen_On_Object_Select;
	_Screen_On_Object_Deselect		= Screen_On_Object_Deselect;

	Display_Objects_Clear();
	Display_Screen_Transition_Start(direction_out, direction_in, type, frame_duration);


    //////////////////////////////
	// Add Display Objects here //
	//////////////////////////////
	Display_Objects_Add_Select_Value(_Title, _Title_Length, &_Display_Value, _Config->Max, _Config->Min, (char*)_Config->Format, &_Configuration_Default_Select_Value);
    _Object_Message_Box = Display_Objects_Add_Message_Box(CENTER_MIDDLE, BOTH_IN_PERCENT, 50, 50, "Saved", MESSAGE_BOX_ICON_CIRCLE_CHECKMARK, &_Message_Box_Style_Regular);

    Display_Select_Object();

    UI_Control_Acceleration_Reset();
    UI_Control_Acceleration_Set_Enabled(_Config->Use_Acceleration);
}

void Screen_Tick(void)
{
    if(_Decision_Made) {
        _Counter++;
    }

    if(_Counter == MESSAGE_BOX_DEFAULT_TICKS) {
        Screen_Setup_Settings_Hierarchical_Menu(TRANSITION_DOWN, TRANSITION_RIGHT, SCREEN_TRANSITION_DEFAULT_EASING, SCREEN_TRANSITION_DEFAULT_FRAMES, _Return_Menu, _Return_List, _Return_Selected_Item);
    }
}

void Screen_Click(uint button_return_value)
{
	
}

void Screen_Touch_Event(int16_t x, int16_t y)
{

}

void Screen_Action_CW(Object_ID object_id)
{
    if(_Decision_Made) {
        return;
    }
    
    UI_Control_Selector_Inc(_Value, _Config->Min, _Config->Max, _Config->Cycle_Selector);

    _Display_Value = *_Value * _Config->Value_Display_Ratio;
}

void Screen_Action_CCW(Object_ID object_id)
{
    if(_Decision_Made) {
        return;
    }
    
    UI_Control_Selector_Dec(_Value, _Config->Min, _Config->Max, _Config->Cycle_Selector);

    _Display_Value = *_Value * _Config->Value_Display_Ratio;
}

void Screen_On_Object_Focused(Object_ID object_id)
{

}

void Screen_On_Object_Defocused(Object_ID object_id)
{
	
}

void Screen_On_Object_Select(Object_ID object_id)
{

}

void Screen_On_Object_Deselect(Object_ID object_id)
{
    if(!_Decision_Made) {
        Display_Objects_Show_Message_Box(_Object_Message_Box, MESSAGE_BOX_DEFAULT_TICKS);
        _Decision_Made = true;
    }
}


/*******************************************************************
    Internal Functions
*******************************************************************/

